"Import issues" and "Import time entries" pages are visible to users without "Add issues" and "Log

spent time" permissions

2024-10-10 10:52 - Kenta Kumojima

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Importers Estimated time: 0.00 hour

Target version: 5.0.10   

Resolution: Fixed Affected version:  

Description

User without log_time permission can access /time_entry/imports/new. (this user has import_time_entry permission)

if the user try to import, internal error occured.

ActionView::Template::Error (undefined method `activities' for nil:NilClass

    project.activities

           ^^^^^^^^^^^):

Causes:

NoMethodError (undefined method `activities' for nil:NilClass

    project.activities

           ^^^^^^^^^^^)

     7: <p>

     8:   <label for="import_mapping_activity"><%= l(:field_activity) %></label>

     9:   <%= mapping_select_tag @import, 'activity', :required => true,

    10:         :values => @import.allowed_target_activities.sorted.map {|t| [t.name, t.id]} %>

    11: </p>

    12:

    13: <div class="splitcontent">

app/models/time_entry_import.rb:52:in `allowed_target_activities'

app/views/imports/_time_entries_fields_mapping.html.erb:10

app/views/imports/_time_entries_mapping.html.erb:4

app/views/imports/mapping.html.erb:4

app/views/imports/mapping.html.erb:3

lib/redmine/sudo_mode.rb:78:in `sudo_mode'

 so, this patch adds checking log_time permission to `TimeEntryImport.authorized?.`

Associated revisions

Revision 23178 - 2024-11-03 06:41 - Go MAEDA

Fix: "Import issues" and "Import time entries" pages are visible to users without "Add issues" and "Log spent time" permissions (#41465).

Patch by Kenta Kumojima (user:kumojima).

Revision 23179 - 2024-11-03 06:51 - Go MAEDA

Merged r23178 from trunk to 5.1-stable (#41465).

Revision 23180 - 2024-11-03 07:00 - Go MAEDA

Merged r23178 from trunk to 5.0-stable (#41465).

History

#1 - 2024-10-10 10:57 - Kenta Kumojima

- File import_time_entry.patch added
fix patch

#2 - 2024-10-10 11:44 - Go MAEDA

- Tracker changed from Patch to Defect

- Status changed from New to Confirmed

Thank you for detecting and reporting the issue.

I found IssueImport.authorized? has a similar problem. It should check :add_issues permission.

#3 - 2024-10-10 11:45 - Go MAEDA

- Target version set to 5.0.10

#4 - 2024-10-11 17:01 - Kenta Kumojima

- File import_issue_and_time_entry.patch added

I found IssueImport.authorized? has a similar problem. It should check :add_issues permission.

 I added checking add_issues permission when importing issues and updated patch.

#5 - 2024-10-28 03:04 - Go MAEDA

- File import_issue_and_time_entry-v2.patch added

- Subject changed from User without log_time permission can access /time_entry/imports/new to "Import issues" and "Import time entries" pages are

visible to users without "Add issues" and "Log spent time" permissions

I have updated the patch to apply to the current trunk cleanly.

#6 - 2024-11-03 07:15 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

I have committed the fix in r23178. Thank you for your contribution.

I didn't set this issue's category to "Security" because, although the import pages are visible to users without permissions, the import process will fail.

Files

import_time_entry.patch 2.49 KB 2024-10-10 Kenta Kumojima

import_time_entry.patch 2.54 KB 2024-10-10 Kenta Kumojima

import_issue_and_time_entry.patch 5.08 KB 2024-10-11 Kenta Kumojima

import_issue_and_time_entry-v2.patch 3.47 KB 2024-10-28 Go MAEDA
